import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.*;  
import java.io.*; 
import java.nio.*;
import java.util.*;  
import java.lang.*;  
import java.nio.ByteBuffer;
import java.nio.channels.AsynchronousServerSocketChannel;
import java.nio.channels.AsynchronousSocketChannel;
import java.net.InetSocketAddress;
import java.nio.channels.CompletionHandler;
import java.nio.channels.*;
import java.awt.Rectangle;

public class Communicator
{   
    private int removeIndexFromList;
    private ArrayList<HeroStats> list = new ArrayList<HeroStats>();
    private ArrayList<Rectangle> mapList = new ArrayList<Rectangle>();
    private ArrayList<Shot> shotList = new ArrayList<Shot>();
    private ArrayList<Shot> shotList2 = new ArrayList<Shot>();
    private ArrayList<Shot> incommingShotList = new ArrayList<Shot>();
    private Socket socket = null;
    private int numberOfPlayers = -1;
    private ServerSocket ss = null;
    private final Communicator c = this;
    private boolean newClient;
    private HeroStats stat = new HeroStats();
    private HeroStats pokus = new HeroStats();
    private int SHOT_SPEED = 10;
    private int idOfShot;

    private final Communicator communicator = this;

    public Communicator()
    {
        establishConnection();
    }

    public void establishConnection()
    {
        loadMap();
        try
        {
            ss = new ServerSocket(4445);
        }
        catch(IOException e)
        {
            e.printStackTrace();
            System.out.println("Server error");
        }
        while(true)
        {
            try
            {
                socket = ss.accept();
                numberOfPlayers++;
                receive();
                send();
                System.out.println("connection Established");
            }
            catch(Exception e)
            {
                e.printStackTrace();
                System.out.println("Connection Error");
            }
        }
    }

    public void receive()
    {

        Thread serverThread = new ServerThread(socket)
            {
                @Override
                @SuppressWarnings("unchecked")
                public void run() 
                {
                    InputStream is = null;
                    OutputStream os = null;
                    ObjectOutputStream oos = null;
                    ObjectInputStream ois = null;

                    String line = null;
                    boolean stop = false;

                    try
                    {
                        s.setTcpNoDelay(true);
                        is = s.getInputStream();
                        ois = new ObjectInputStream(is);
                    }
                    catch(Exception e)
                    {
                        System.out.println(e);
                        stop = true;
                    }

                    while(!stop)
                    {
                        try
                        {
                            stat = (HeroStats)(ois.readObject());
                            incommingShotList = (ArrayList<Shot>)(ois.readObject());
                            for(Shot s : incommingShotList)
                            {
                                s.serverId = idOfShot;
                                shotList.add(s);
                                idOfShot++;
                            }

                            /*for(Shot s : shotList)
                            {
                            int a = 0;
                            System.out.println(a+" shot c= " + s.c + " q= "+s.q);
                            a++;
                            }*/
                        }
                        catch (IOException e) 
                        {
                            System.out.println(e);
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("IO Error/ Client "+line+" terminated abruptly");
                            stop = true;
                        }
                        catch(NullPointerException e)
                        {
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("Client "+line+" Closed");
                            stop = true;
                        }
                        catch(Exception e)
                        {
                            System.out.println(e+"chyba je v receive");
                            stop = true;
                        }

                        boolean idFound = false;

                        synchronized(list)
                        {
                            for(int i = 0; i < list.size(); i++)
                            {
                                if(list.get(i).id == stat.id)
                                {
                                    list.set(i, stat);
                                    idFound = true;
                                }
                            }
                            if(!idFound)
                            {
                                //System.out.println("NENI pritomno v listu");
                                list.add(stat);
                            }
                        }

                        /**
                         * Kdyz skonci spojeni, vymaz hrace
                         */
                        if(stop)
                            list.clear();
                        /*if(stop)
                        {
                        Iterator<HeroStats> it = list.iterator();
                        while (it.hasNext()) 
                        {
                        HeroStats h = it.next();
                        if (h.id == stat.id) 
                        {
                        System.out.println("id "+h.id+" bylo smazano");
                        it.remove();
                        }
                        }
                        }*/

                    }
                }
            };
        serverThread.start();
    }

    public void send()
    {
        Thread serverThread = new ServerThread(socket)
            {
                @Override
                public void run() 
                {
                    InputStream is = null;
                    OutputStream os = null;
                    ObjectOutputStream oos = null;
                    ObjectInputStream ois = null;

                    Socket s = socket;
                    String line = null;

                    HeroStats stats = null;
                    boolean stop = false;

                    try
                    {
                        os = s.getOutputStream();
                        oos = new ObjectOutputStream(os);
                    }
                    catch(NullPointerException e)
                    {
                        line=this.getName(); //reused String line for getting thread name
                        System.out.println("Client "+line+" Closed");
                        stop = true;
                    }
                    catch(Exception e)
                    {
                        System.out.println(e+"chyba je v send");
                        stop = true;
                    }

                    while(!stop)
                    {
                        shotMove();
                        checkShotCollisions();
                        try
                        { 
                            Thread.sleep(25);
                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                        }

                        try
                        {
                            synchronized(list)
                            {
                                /*for(HeroStats tmp : list)
                                {
                                System.out.println(s);
                                System.out.println("TADY TI NAPISU id - "+tmp.id);
                                System.out.println("TADY TI NAPISU x - "+tmp.x);
                                System.out.println("TADY TI NAPISU Y - "+tmp.y);
                                }*/
                                oos.writeObject(list);

                                synchronized(shotList)
                                {
                                    shotList2 = new ArrayList<Shot>();
                                    shotList2 = (ArrayList<Shot>)(shotList.clone());

                                    oos.writeObject(shotList2);
                                }

                                oos.flush();
                                oos.reset();
                            }
                        }
                        catch (IOException e) 
                        {
                            System.out.println(e);
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("IO Error/ Client "+line+" terminated abruptly");
                            stop = true;
                        }
                        catch(NullPointerException e)
                        {
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("Client "+line+" Closed");
                            stop = true;
                        }
                        catch(Exception e)
                        {
                            System.out.println(e+"chyba je v send2");
                            stop = true;
                        }
                    }
                }
            };
        serverThread.start();
    }

    public void shotMove()
    {
        /*for(Shot tmp : shotList)
        {
        //tmp.x++;
        System.out.println(tmp.x);
        }*/

        for( Iterator<Shot> it = shotList2.iterator(); it.hasNext() ; )
        {
            Shot tmp = it.next();
            if(tmp.isLeft)
                tmp.x -= SHOT_SPEED;
            else
                tmp.x += SHOT_SPEED;
            //System.out.println(tmp.x);
        }

        /*Thread thread = new Thread()
        {
        public void run() 
        {
        for(Shot tmp : shotList)
        {
        tmp.x++;
        }
        }
        };
        thread.start();    */
    }

    public void loadMap()
    {
        // obrys
        mapList.add(new Rectangle(0, 0, 1008, 5));
        mapList.add(new Rectangle(0, 0, 5, 740));
        mapList.add(new Rectangle(0, 710, 1008, 5));
        mapList.add(new Rectangle(1008, 0, 5, 740));
        //mapList.add(new Rectangle(500, 0, 5, 740));
        //patra
        mapList.add(new Rectangle(100, 650, 250, 5));
        mapList.add(new Rectangle(200, 590, 400, 5));
    }

    public void checkShotCollisions()
    {

        ArrayList<Integer> indexToDelete = new ArrayList<Integer>();
        Rectangle shotRectangle = new Rectangle();
        for( Iterator<Shot> it = shotList2.iterator(); it.hasNext() ; )
        {
            Shot s = it.next();

            //STENY, PATRA atp.
            shotRectangle = s.getRectangle();

            for(Rectangle wall : mapList)
            {
                if(shotRectangle.intersects(wall))
                {
                    indexToDelete.add(s.serverId);
                }
            }

            // PANACKOVE    
            Rectangle hero = new Rectangle();
            for(HeroStats h : list)
            {
                hero = h.getRectangle();
                if(shotRectangle.intersects(hero))
                {
                    if(h.id != s.id)
                    {
                        indexToDelete.add(s.serverId);
                    }
                }
            }
        }
        for(int del : indexToDelete)
        {
            System.out.println("INDEX TO DELETE JSOU: "+del);
            for( Iterator<Shot> iter = shotList2.iterator(); iter.hasNext() ; )
            {
                Shot delShot = iter.next();
                System.out.println(delShot.serverId);
                if(delShot.serverId == del)
                {
                    System.out.println("bingo");
                    System.out.println(shotList2.size());
                    iter.remove();
                    System.out.println(shotList2.size());
                }

            }
        }
        shotList = shotList2; //concurent exception... o_O

    }

    class ServerThread extends Thread
    {
        Socket s;
        public ServerThread(Socket s)
        {
            this.s = s;
        }

        public void run()
        {

        }

    }

}
